Loading...
Searching...
No Matches
peak_detector.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2007,2013,2018 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef PEAK_DETECTOR_H
#define PEAK_DETECTOR_H
#include <gnuradio/blocks/api.h>
#include <gnuradio/sync_block.h>
#include <cstdint>
namespace gr {
namespace blocks {
/*!
* \brief Detect the peak of a signal
* \ingroup peak_detectors_blk
*
* \details
* If a peak is detected, this block outputs a 1,
* or it outputs 0's.
*/
template <class T>
class BLOCKS_API peak_detector : virtual public sync_block
{
public:
typedef std::shared_ptr<peak_detector<T>> sptr;
/*!
* Make a peak detector block.
*
* \param threshold_factor_rise The threshold factor determines
* when a peak has started. An average of the signal is
* calculated and when the value of the signal goes over
* threshold_factor_rise*average, we start looking for a
* peak.
* \param threshold_factor_fall The threshold factor determines
* when a peak has ended. An average of the signal is
* calculated and when the value of the signal goes
* below threshold_factor_fall*average, we stop looking
* for a peak.
* \param look_ahead The look-ahead value is used when the
* threshold is found to look if there another peak
* within this step range. If there is a larger value,
* we set that as the peak and look ahead again. This is
* continued until the highest point is found with This
* look-ahead range.
* \param alpha The gain value of a moving average filter
*/
static sptr make(float threshold_factor_rise = 0.25,
float threshold_factor_fall = 0.40,
int look_ahead = 10,
float alpha = 0.001);
/*! \brief Set the threshold factor value for the rise time
* \param thr new threshold factor
*/
virtual void set_threshold_factor_rise(float thr) = 0;
/*! \brief Set the threshold factor value for the fall time
* \param thr new threshold factor
*/
virtual void set_threshold_factor_fall(float thr) = 0;
/*! \brief Set the look-ahead factor
* \param look new look-ahead factor
*/
virtual void set_look_ahead(int look) = 0;
/*! \brief Set the running average alpha
* \param alpha new alpha for running average
*/
virtual void set_alpha(float alpha) = 0;
/*! \brief Get the threshold factor value for the rise time
* \return threshold factor
*/
virtual float threshold_factor_rise() = 0;
/*! \brief Get the threshold factor value for the fall time
* \return threshold factor
*/
virtual float threshold_factor_fall() = 0;
/*! \brief Get the look-ahead factor value
* \return look-ahead factor
*/
virtual int look_ahead() = 0;
/*! \brief Get the alpha value of the running average
* \return alpha
*/
virtual float alpha() = 0;
};
typedef peak_detector<float> peak_detector_fb;
typedef peak_detector<std::int32_t> peak_detector_ib;
typedef peak_detector<std::int16_t> peak_detector_sb;
} /* namespace blocks */
} /* namespace gr */
#endif /* PEAK_DETECTOR_H */
gr::blocks::peak_detector
Detect the peak of a signal.
Definition peak_detector.h:31
gr::blocks::peak_detector::sptr
std::shared_ptr< peak_detector< T > > sptr
Definition peak_detector.h:33
gr::blocks::peak_detector< float >::threshold_factor_rise
virtual float threshold_factor_rise()=0
gr::blocks::peak_detector::set_look_ahead
virtual void set_look_ahead(int look)=0
Set the look-ahead factor.
gr::blocks::peak_detector::set_threshold_factor_fall
virtual void set_threshold_factor_fall(float thr)=0
Set the threshold factor value for the fall time.
gr::blocks::peak_detector< float >::alpha
virtual float alpha()=0
gr::blocks::peak_detector::make
static sptr make(float threshold_factor_rise=0.25, float threshold_factor_fall=0.40, int look_ahead=10, float alpha=0.001)
gr::blocks::peak_detector::set_alpha
virtual void set_alpha(float alpha)=0
Set the running average alpha.
gr::blocks::peak_detector< float >::look_ahead
virtual int look_ahead()=0
gr::blocks::peak_detector< float >::threshold_factor_fall
virtual float threshold_factor_fall()=0
gr::blocks::peak_detector::set_threshold_factor_rise
virtual void set_threshold_factor_rise(float thr)=0
Set the threshold factor value for the rise time.
gr::sync_block::sync_block
sync_block(void)
Definition sync_block.h:28
api.h
BLOCKS_API
#define BLOCKS_API
Definition gr-blocks/include/gnuradio/blocks/api.h:18
gr::blocks
Definition abs_blk.h:20
gr::blocks::peak_detector_ib
peak_detector< std::int32_t > peak_detector_ib
Definition peak_detector.h:103
gr::blocks::peak_detector_sb
peak_detector< std::int16_t > peak_detector_sb
Definition peak_detector.h:104
gr::blocks::peak_detector_fb
peak_detector< float > peak_detector_fb
Definition peak_detector.h:102
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
sync_block.h